(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms'], factory) :
	(factory((global['angularx-flatpickr'] = {}),global.ng.core,global.ng.forms));
}(this, (function (exports,core,forms) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */
var FlatpickrDefaults = /** @class */ (function () {
    function FlatpickrDefaults() {
        /**
         * Exactly the same as date format, but for the altInput field.
         */
        this.altFormat = 'F j, Y';
        /**
         * 	Show the user a readable date (as per altFormat), but return something totally different to the server.
         */
        this.altInput = false;
        /**
         * This class will be added to the input element created by the altInput option.
         * Note that `altInput` already inherits classes from the original input.
         */
        this.altInputClass = '';
        /**
         * Allows the user to enter a date directly input the input field. By default, direct entry is disabled.
         */
        this.allowInput = false;
        /**
         * Instead of `body`, appends the calendar to the specified node instead.
         */
        this.appendTo = undefined;
        /**
         * Whether clicking on the input should open the picker.
         * You could disable this if you wish to open the calendar manually `with.open()`.
         */
        this.clickOpens = true;
        /**
         * A string of characters which are used to define how the date will be displayed in the input box.
         * The supported characters are defined in the table below.
         */
        this.dateFormat = 'Y-m-d';
        /**
         * See <a href="https://chmln.github.io/flatpickr/examples/#disabling-specific-dates">disabling dates</a>.
         */
        this.disable = [];
        /**
         * Set disableMobile to true to always use the non-native picker.
         * By default, Flatpickr utilizes native datetime widgets unless certain options (e.g. disable) are used.
         */
        this.disableMobile = false;
        /**
         * See <a href="https://chmln.github.io/flatpickr/examples/#disabling-all-dates-except-select-few">enabling dates</a>.
         */
        this.enable = [];
        /**
         * Enables time picker.
         */
        this.enableTime = false;
        /**
         * Enables seconds in the time picker.
         */
        this.enableSeconds = false;
        /**
         * Adjusts the step for the hour input (incl. scrolling).
         */
        this.hourIncrement = 1;
        /**
         * Displays the calendar inline.
         */
        this.inline = false;
        /**
         * The maximum date that a user can pick to (inclusive).
         */
        this.maxDate = undefined;
        /**
         * The minimum date that a user can start picking from (inclusive).
         */
        this.minDate = undefined;
        /**
         * Adjusts the step for the minute input (incl. scrolling).
         */
        this.minuteIncrement = 5;
        /**
         * Select a single date, multiple dates or a date range.
         */
        this.mode = 'single';
        /**
         * HTML for the arrow icon, used to switch months.
         */
        this.nextArrow = '>';
        /**
         * Hides the day selection in calendar. Use it along with `enableTime` to create a time picker.
         */
        this.noCalendar = false;
        /**
         * HTML for the left arrow icon.
         */
        this.prevArrow = '<';
        /**
         * Show the month using the shorthand version (ie, Sep instead of September).
         */
        this.shorthandCurrentMonth = false;
        /**
         * Position the calendar inside the wrapper and next to the input element. (Leave `false` unless you know what you're doing).
         */
        this.static = false;
        /**
         * Displays time picker in 24 hour mode without AM/PM selection when enabled.
         */
        this.time24hr = false;
        /**
         * When true, dates will parsed, formatted, and displayed in UTC.
         * It's recommended that date strings contain the timezone, but not necessary.
         */
        this.utc = false;
        /**
         * Enables display of week numbers in calendar.
         */
        this.weekNumbers = false;
        /**
         * Custom elements and input groups.
         */
        this.wrap = false;
        /**
         * Array of plugin instances to use.
         */
        this.plugins = [];
        /**
         * Auto convert the ngModel value from a string to a date / array of dates / from - to date object depending on the `mode`
         */
        this.convertModelValue = false;
    }
    return FlatpickrDefaults;
}());
FlatpickrDefaults.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
FlatpickrDefaults.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var FLATPICKR = new core.InjectionToken('flatpickr');
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */
/**
 * @record
 */
var FLATPICKR_CONTROL_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return FlatpickrDirective; }),
    //tslint:disable-line
    multi: true
};
var FlatpickrDirective = /** @class */ (function () {
    /**
     * @param {?} elm
     * @param {?} defaults
     * @param {?} flatpickr
     */
    function FlatpickrDirective(elm, defaults, flatpickr) {
        this.elm = elm;
        this.defaults = defaults;
        this.flatpickr = flatpickr;
        /**
         * Gets triggered once the calendar is in a ready state
         */
        this.flatpickrReady = new core.EventEmitter();
        /**
         * Gets triggered when the user selects a date, or changes the time on a selected date.
         */
        this.flatpickrChange = new core.EventEmitter();
        /**
         * Gets triggered when the input value is updated with a new date string.
         */
        this.flatpickrValueUpdate = new core.EventEmitter();
        /**
         * Gets triggered when the calendar is opened.
         */
        this.flatpickrOpen = new core.EventEmitter();
        /**
         * Gets triggered when the calendar is closed.
         */
        this.flatpickrClose = new core.EventEmitter();
        /**
         * Gets triggered when the month is changed, either by the user or programmatically.
         */
        this.flatpickrMonthChange = new core.EventEmitter();
        /**
         * Gets triggered when the year is changed, either by the user or programmatically.
         */
        this.flatpickrYearChange = new core.EventEmitter();
        /**
         * Take full control of every date cell with this output
         */
        this.flatpickrDayCreate = new core.EventEmitter();
        this.onChangeFn = function () { };
    }
    /**
     * @return {?}
     */
    FlatpickrDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        var /** @type {?} */ options = {
            altFormat: this.altFormat,
            altInput: this.altInput,
            altInputClass: this.altInputClass,
            allowInput: this.allowInput,
            appendTo: this.appendTo,
            clickOpens: this.clickOpens,
            dateFormat: this.dateFormat,
            disable: this.disable,
            disableMobile: this.disableMobile,
            enable: this.enable,
            enableTime: this.enableTime,
            enableSeconds: this.enableSeconds,
            hourIncrement: this.hourIncrement,
            defaultDate: this.initialValue,
            inline: this.inline,
            maxDate: this.maxDate,
            minDate: this.minDate,
            minuteIncrement: this.minuteIncrement,
            mode: this.mode,
            nextArrow: this.nextArrow,
            noCalendar: this.noCalendar,
            parseDate: this.parseDate,
            prevArrow: this.prevArrow,
            shorthandCurrentMonth: this.shorthandCurrentMonth,
            static: this.static,
            time24hr: this.time24hr,
            weekNumbers: this.weekNumbers,
            getWeek: this.getWeek,
            wrap: this.wrap,
            plugins: this.plugins,
            onChange: function (selectedDates, dateString, instance) {
                _this.flatpickrChange.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onOpen: function (selectedDates, dateString, instance) {
                _this.flatpickrOpen.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onClose: function (selectedDates, dateString, instance) {
                _this.flatpickrClose.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onMonthChange: function (selectedDates, dateString, instance) {
                _this.flatpickrMonthChange.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onYearChange: function (selectedDates, dateString, instance) {
                _this.flatpickrYearChange.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onReady: function (selectedDates, dateString, instance) {
                _this.flatpickrReady.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onValueUpdate: function (selectedDates, dateString, instance) {
                _this.flatpickrValueUpdate.emit({ selectedDates: selectedDates, dateString: dateString, instance: instance });
            },
            onDayCreate: function (selectedDates, dateString, instance, dayElement) {
                _this.flatpickrDayCreate.emit({
                    selectedDates: selectedDates,
                    dateString: dateString,
                    instance: instance,
                    dayElement: dayElement
                });
            }
        };
        if (this.locale) {
            // workaround warning from flatpickr
            options.locale = this.locale;
        }
        Object.keys(options).forEach(function (key) {
            if (typeof options[key] === 'undefined') {
                options[key] = ((_this)).defaults[key];
            }
        });
        options.time_24hr = options.time24hr;
        this.instance = this.flatpickr(this.elm.nativeElement, options);
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    FlatpickrDirective.prototype.ngOnChanges = function (changes) {
        var _this = this;
        if (this.instance) {
            Object.keys(changes).forEach(function (inputKey) {
                _this.instance.set(inputKey, ((_this))[inputKey]);
            });
        }
    };
    /**
     * @return {?}
     */
    FlatpickrDirective.prototype.ngOnDestroy = function () {
        this.instance.destroy();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    FlatpickrDirective.prototype.writeValue = function (value) {
        var /** @type {?} */ convertedValue = value;
        if (this.convertModelValue && this.mode === 'range' && value) {
            convertedValue = [value.from, value.to];
        }
        if (this.instance) {
            this.instance.setDate(convertedValue);
        }
        else {
            // flatpickr hasn't been initialised yet, store the value for later use
            this.initialValue = convertedValue;
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    FlatpickrDirective.prototype.registerOnChange = function (fn) {
        this.onChangeFn = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    FlatpickrDirective.prototype.registerOnTouched = function (fn) { };
    /**
     * @return {?}
     */
    FlatpickrDirective.prototype.inputChanged = function () {
        var /** @type {?} */ value = this.elm.nativeElement.value;
        if (this.convertModelValue && typeof value === 'string') {
            switch (this.mode) {
                case 'multiple':
                    var /** @type {?} */ dates = value.split('; ').map(function (str) { return new Date(str); });
                    this.onChangeFn(dates);
                    break;
                case 'range':
                    var _a = value.split(' to ').map(function (str) { return new Date(str); }), from = _a[0], to = _a[1];
                    this.onChangeFn({ from: from, to: to });
                    break;
                case 'single':
                default:
                    this.onChangeFn(new Date(value));
            }
        }
        else {
            this.onChangeFn(value);
        }
    };
    return FlatpickrDirective;
}());
FlatpickrDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[mwlFlatpickr]',
                providers: [FLATPICKR_CONTROL_VALUE_ACCESSOR]
            },] },
];
/** @nocollapse */
FlatpickrDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
    { type: FlatpickrDefaults, },
    { type: undefined, decorators: [{ type: core.Inject, args: [FLATPICKR,] },] },
]; };
FlatpickrDirective.propDecorators = {
    "altFormat": [{ type: core.Input },],
    "altInput": [{ type: core.Input },],
    "altInputClass": [{ type: core.Input },],
    "allowInput": [{ type: core.Input },],
    "appendTo": [{ type: core.Input },],
    "clickOpens": [{ type: core.Input },],
    "dateFormat": [{ type: core.Input },],
    "disable": [{ type: core.Input },],
    "disableMobile": [{ type: core.Input },],
    "enable": [{ type: core.Input },],
    "enableTime": [{ type: core.Input },],
    "enableSeconds": [{ type: core.Input },],
    "hourIncrement": [{ type: core.Input },],
    "inline": [{ type: core.Input },],
    "maxDate": [{ type: core.Input },],
    "minDate": [{ type: core.Input },],
    "minuteIncrement": [{ type: core.Input },],
    "mode": [{ type: core.Input },],
    "nextArrow": [{ type: core.Input },],
    "noCalendar": [{ type: core.Input },],
    "parseDate": [{ type: core.Input },],
    "prevArrow": [{ type: core.Input },],
    "shorthandCurrentMonth": [{ type: core.Input },],
    "static": [{ type: core.Input },],
    "time24hr": [{ type: core.Input },],
    "weekNumbers": [{ type: core.Input },],
    "getWeek": [{ type: core.Input },],
    "wrap": [{ type: core.Input },],
    "plugins": [{ type: core.Input },],
    "locale": [{ type: core.Input },],
    "convertModelValue": [{ type: core.Input },],
    "flatpickrReady": [{ type: core.Output },],
    "flatpickrChange": [{ type: core.Output },],
    "flatpickrValueUpdate": [{ type: core.Output },],
    "flatpickrOpen": [{ type: core.Output },],
    "flatpickrClose": [{ type: core.Output },],
    "flatpickrMonthChange": [{ type: core.Output },],
    "flatpickrYearChange": [{ type: core.Output },],
    "flatpickrDayCreate": [{ type: core.Output },],
    "inputChanged": [{ type: core.HostListener, args: ['input',] },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var USER_DEFAULTS = new core.InjectionToken('flatpickr defaults');
/**
 * @param {?} userDefaults
 * @return {?}
 */
function defaultsFactory(userDefaults) {
    var /** @type {?} */ defaults = new FlatpickrDefaults();
    Object.assign(defaults, userDefaults);
    return defaults;
}
var FlatpickrModule = /** @class */ (function () {
    function FlatpickrModule() {
    }
    /**
     * @param {?} flatpickr
     * @param {?=} userDefaults
     * @return {?}
     */
    FlatpickrModule.forRoot = function (flatpickr, userDefaults) {
        if (userDefaults === void 0) { userDefaults = {}; }
        return {
            ngModule: FlatpickrModule,
            providers: [
                flatpickr,
                {
                    provide: USER_DEFAULTS,
                    useValue: userDefaults
                },
                {
                    provide: FlatpickrDefaults,
                    useFactory: defaultsFactory,
                    deps: [USER_DEFAULTS]
                }
            ]
        };
    };
    return FlatpickrModule;
}());
FlatpickrModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [FlatpickrDirective],
                exports: [FlatpickrDirective]
            },] },
];
/** @nocollapse */
FlatpickrModule.ctorParameters = function () { return []; };

exports.FlatpickrDefaults = FlatpickrDefaults;
exports.USER_DEFAULTS = USER_DEFAULTS;
exports.defaultsFactory = defaultsFactory;
exports.FlatpickrModule = FlatpickrModule;
exports.FLATPICKR = FLATPICKR;
exports.ɵa = FLATPICKR_CONTROL_VALUE_ACCESSOR;
exports.ɵb = FlatpickrDirective;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angularx-flatpickr.umd.js.map
